<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SemanticSearchImplementation: Main Page</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SemanticSearchImplementation
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">SemanticSearchImplementation Documentation</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p><a class="anchor" id="md_C__Users_sb-admin_source_repos_SemanticSearchImplementation_readme"></a>This repository contains the code created in the master thesis <a href="http://dx.doi.org/10.18154/RWTH-2020-09883">"An Efficient Semantic Search Engine for Research Data in an RDF-based Knowledge Graph"</a> to implement a search engine for RDF-based metadata graphs based on Virtuoso, Elasticsearch and the developed mapping of the data.</p>
<h2><a class="anchor" id="autotoc_md0"></a>
Code documentation:</h2>
<p>The code documentation can be found under *./docs/index.html*.</p>
<h2><a class="anchor" id="autotoc_md1"></a>
Setup/Prerequisites:</h2>
<ul>
<li>Virtuoso<ul>
<li>Virtuoso.ini file<ul>
<li>NumberOfBuffers &gt;= 660000</li>
<li>MaxDirtyBuffers &gt;= 495000</li>
</ul>
</li>
<li>Define the following graphs as rulesets named "ruleset" for inference rules with &lsquo;rdfs_rule_set (&rsquo;&lt;rulesetname&gt;', '&lt;graphname&gt;') ;`<ul>
<li><a href="http://www.dfg.de/dfg_profil/gremien/fachkollegien/faecher/">http://www.dfg.de/dfg_profil/gremien/fachkollegien/faecher/</a></li>
<li><a href="http://www.w3.org/ns/org#">http://www.w3.org/ns/org#</a></li>
<li><a href="http://xmlns.com/foaf/0.1/">http://xmlns.com/foaf/0.1/</a></li>
</ul>
</li>
</ul>
</li>
<li>Data mentioned in <a href="http://dx.doi.org/10.18154/RWTH-2020-09886">"Sample Dataset for Search Engine Evaluation for Research Data in an RDF-based Knowledge Graph"</a><ul>
<li>All named_graphs, use virtuoso.db/graphs.db</li>
</ul>
</li>
<li>Elasticsearch</li>
<li>Specified packages</li>
</ul>
<h2><a class="anchor" id="autotoc_md2"></a>
How to use:</h2>
<ol type="1">
<li>Install/restore necessary packages</li>
<li>Build solution</li>
<li>Start Virtuoso</li>
<li>Start Elasticsearch</li>
<li>Run <em>SemanticSearchImplementation.exe</em> with the necessary arguments</li>
</ol>
<h3><a class="anchor" id="autotoc_md3"></a>
Commandline arguments</h3>
<table class="markdownTable">
<tr class="markdownTableHead">
<th class="markdownTableHeadNone">Option  </th><th class="markdownTableHeadNone">Description   </th></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">-a, &ndash;action  </td><td class="markdownTableBodyNone">Required. Possible action: search, reindex, index, delete or add   </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">-v  </td><td class="markdownTableBodyNone">(Default: localhost) Server name of Virtuoso   </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">&ndash;vp  </td><td class="markdownTableBodyNone">(Default: 1111) Port of Virtuoso   </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">&ndash;db  </td><td class="markdownTableBodyNone">(Default: db) DB of Virtuoso   </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">&ndash;dbUser  </td><td class="markdownTableBodyNone">(Default: dba) Database user of Virtuoso   </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">&ndash;dbPassword  </td><td class="markdownTableBodyNone">(Default: dba) Database password of Virtuoso   </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">-e  </td><td class="markdownTableBodyNone">(Default: localhost) Server name of Elasticsearch   </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">&ndash;ep  </td><td class="markdownTableBodyNone">(Default: 9200) Port of Elasticsearch   </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">-l  </td><td class="markdownTableBodyNone">(Default: en) Specify language   </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">-d, &ndash;doc  </td><td class="markdownTableBodyNone">ID of metadata graph   </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">-q, &ndash;query  </td><td class="markdownTableBodyNone">(Default: *) Elasticsearch query   </td></tr>
<tr class="markdownTableRowEven">
<td class="markdownTableBodyNone">&ndash;adv  </td><td class="markdownTableBodyNone">(Default: false) Set true for advanced Elasticsearch search syntax   </td></tr>
<tr class="markdownTableRowOdd">
<td class="markdownTableBodyNone">-u, &ndash;user  </td><td class="markdownTableBodyNone">(Default: ) Specify user or only public metadata records could be found   </td></tr>
</table>
</div></div><!-- PageDoc -->
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
